//
//  Copyright (C) by S.Tomabechi 1994
//  All rights reserved.
//
//  read bit string in binary mode 
//
#include "TBit.hpp"

void read(istream& is,TBit& B)
{
  long narray ;
  is.read((char*)&narray,sizeof(narray)) ;  // size of array
  is.read((char*)&B.size,sizeof(B.size)) ;  // length of bit string   size<=narray*32
  if( narray>B.nArray ) {                   // enlarge array 
    delete [] B.bit ;
    B.bit=new unsigned long[narray] ;
  }
  B.nArray=narray ;
  is.read((char*)B.bit,sizeof(unsigned long)*B.nArray) ;
}
