//
//  Copyright (C) by S.Tomabechi 1994
//  All rights reserved.
//
//  scan non-zero bit backward
//
//  0 łȂrbgʒuT
//  ŏʃrbgŉʃrbgɌ 0 łȂrbgʒuT
//  ̈ʒuԂ.
//  ׂẴrbg 0 Ȃ -1 Ԃ.
//
#ifdef __BORLANDC__
#pragma inline
#endif
#include "Bit.hpp"

long BitScanReverse(const unsigned long* bit,const long nArray)
{
  long leng(-1) ;
  __asm {
    mov   ecx,nArray
    mov   esi,bit
    or    ecx,ecx
    jz    Zero
    xor   eax,eax
  }
Scan:
  __asm {
    cmp   [ecx*BITBYTE+esi-BITBYTE],eax
    jne   NonZero
    dec   ecx
    jnz   Scan
    jmp   Zero      // all bits are zero
  }
NonZero:
  __asm {
    bsr   eax,[ecx*BITBYTE+esi-BITBYTE]
    dec   ecx
    shl   ecx,5
    add   ecx,eax
    mov   leng,ecx
  }
Zero:
  return leng ;
}

