//
//  Copyright (C) by S.Tomabechi 1993-1997
//  All rights reserved.
//
//  calculate inverse modulo p
//
//  a  mod p ł̋tԂ.
//  t݂ȂƂ́A0 Ԃ.
//  p fłKv͂Ȃ. a  p ݂ɑfł΂悢.
//
//  ̊֐ł, _Mtemp gȂ֐gp邱
//
#ifdef __BORLANDC__
#pragma inline
#endif
#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "MintFunc.hpp"

#ifdef __BORLANDC__
Mint& Mint::isInvModp(const Mint& a,const Mint& p)
{

  Mint d(a) ;
  Mint q ;
  Mint t3 ;
  Mint::_uuMtemp.nDigit=0 ;          // _uuMtemp=0
  Mint::_uuMtemp.nDim&=_POSITIVE_ ;
  Mint ::_vvMtemp=p ;

  nDigit=1 ; *digit=1 ;               // *this <-1
  if( a.isNegative() ) {
    nDim|=_NEGATIVE_ ;
    d.nDim&=_POSITIVE_ ;
  }
  else nDim&=_POSITIVE_ ;

  if( p.isNegative() ) Mint::_vvMtemp.nDim|=_NEGATIVE_ ;

  for(;;) {
    if( Mint::_vvMtemp.isZero() ) {
      if( d.nDigit!=1 || ((unsigned long)d)!=1 ) return *this=0 ;
      else if( isNegative() ) return isAdd(*this,p) ;
      else return *this ;
    }
    divide(d,Mint::_vvMtemp,q,t3) ;

                      //    swap d<->t3
    __asm {
      mov   eax,dword ptr d.digit
      xchg  eax,dword ptr t3.digit
      mov   dword ptr d.digit,eax

      mov   eax,dword ptr d.nDigit
      xchg  eax,dword ptr t3.nDigit
      mov   dword ptr d.nDigit,eax

      mov   eax,dword ptr d.fDigit
      xchg  eax,dword ptr t3.fDigit
      mov   dword ptr d.fDigit,eax

      mov   eax,dword ptr d.nDim
      xchg  eax,dword ptr t3.nDim
      mov   dword ptr d.nDim,eax

    }
    q*=Mint::_uuMtemp ;
    isSub(*this,q) ;

    if( d.isZero() ) {
      if( Mint::_vvMtemp.nDigit!=1 || ((unsigned long)Mint::_vvMtemp)!=1 )
        return *this=0 ;
      else if( Mint::_uuMtemp.isNegative() ) return isAdd(p,Mint::_uuMtemp) ;
      else return *this=Mint::_uuMtemp ;
    }

    divide(Mint::_vvMtemp,d,q,t3) ;

                // swap _vvMtemp <-> t3
    __asm {
      mov   eax,dword ptr [@Mint@_vvMtemp]
      xchg  eax,dword ptr t3.digit
      mov   dword ptr [@Mint@_vvMtemp],eax

      mov   eax,dword ptr [@Mint@_vvMtemp.nDigit]
      xchg  eax,dword ptr t3.nDigit
      mov   dword ptr [@Mint@_vvMtemp.nDigit],eax

      mov   eax,dword ptr [@Mint@_vvMtemp.fDigit]
      xchg  eax,dword ptr t3.fDigit
      mov   dword ptr [@Mint@_vvMtemp.fDigit],eax

      mov   eax,dword ptr [@Mint@_vvMtemp.nDim]
      xchg  eax,dword ptr t3.nDim
      mov   dword ptr [@Mint@_vvMtemp.nDim],eax

    }
    q*=(*this) ;
    Mint::_uuMtemp-=q ;

  }

}
#else
Mint& Mint::isInvModp(const Mint& a,const Mint& p)
{

  Mint d(a) ;
  Mint q ;
  Mint t3 ;
  Mint::_uuMtemp.nDigit=0 ;
  Mint::_uuMtemp.nDim&=_POSITIVE_ ;
  Mint ::_vvMtemp=p ;

  nDigit=1 ; *digit=1 ;
  if( a.isNegative()) { nDim|=_NEGATIVE_ ; d.nDim&=_POSITIVE_ ; }
  else  nDim&=_POSITIVE_ ;

  if( p.isNegative() ) Mint::_vvMtemp.nDim&=_POSITIVE_ ;

  for(;;) {
    if( Mint::_vvMtemp.isZero() ) {
      if( d.nDigit!=1 || ((unsigned long)d)!=1 ) return *this=0 ;
      else if( isNegative() ) return isAdd(*this,p) ;
      else return *this ;
    }
    divide(d,Mint::_vvMtemp,q,t3) ;
    Swap(d,t3) ;
    q*=Mint::_uuMtemp ;
    isSub(*this,q) ;

    if( d.isZero() ) {
      if( Mint::_vvMtemp.nDigit!=1 || ((unsigned long)Mint::_vvMtemp)!=1 )
        return *this=0 ;
      else if( Mint::_uuMtemp.isNegative() ) return isAdd(p,Mint::_uuMtemp) ;
      else return *this=Mint::_uuMtemp ;
    }

    divide(Mint::_vvMtemp,d,q,t3) ;
    Swap(Mint::_vvMtemp,t3) ;
    q*=(*this) ;
    Mint::_uuMtemp-=q ;

  }

}

#endif
