//
//  Copyright (C) by S.Tomabechi 1997
//  All rights reserved.
//
//  returns # of digits ( radix 10 )
//
#include "Mint.hpp"

long len10(const Mint& N)
{
  Mint NN(N) ;
  unsigned long d(1000000000UL) ;      // 10^9
  long inc(9) ;
  long k(1) ;

  if( N==0 ) return 0 ;
  else {
    for(;;) {
      NN/=d ;
      if( NN!=0 ) k+=inc ;
      else {                         // NN < 10^9
        if( inc==1 ) break ;
        NN=Mint::_res ;
        inc=1 ;
        d=10 ;
      }
    }
  }
  return k ;

}