//
//  Copyright (C) by S.Tomabechi 1994,1995,1997
//  All rights reserved.
//
//  negation
//
#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

Mint& Mint::isNeg(const Mint& a)
{
  int anDigit ;

  __asm {
    mov esi,a
    mov edi,this
#ifdef __BORLANDC__
    mov ecx,[esi.nDigit]
#else
    mov ecx,[esi+NDIGIT]
#endif
    cmp esi,edi
    je  NEGATE                // this=&a
  }
  __asm {
    mov anDigit,ecx
#ifdef __BORLANDC__
    mov eax,[edi.nDim]
#else
    mov eax,[edi+NDIM]
#endif
    and eax,_DIGITS_
    cmp ecx,eax                      // a.ndigit<=nDim ?
    jbe EXECUTE
  }

  allocate(anDigit) ;         // enlarge array

  __asm {

    mov   esi,a
    mov   edi,this

    mov   ecx,anDigit
  }
EXECUTE:
  __asm {
#ifdef __BORLANDC__
    mov   eax,[esi.fDigit]
    mov   dl,byte ptr [esi.nDim+3]

    mov   [edi.nDigit],ecx
    mov   [edi.fDigit],eax
    mov   byte ptr [edi.nDim+3],dl

    jecxz RET1                                // this is zero

    mov   esi,[esi]
    mov   edi,[edi]
#else
    mov   eax,[esi+FDIGIT]
    mov   dl,[esi+SIGN]

    mov   [edi+NDIGIT],ecx
    mov   [edi+FDIGIT],eax
    mov   byte ptr [edi+SIGN],dl

    jecxz RET1

    mov   esi,[esi]
    mov   edi,[edi]
#endif
    mov   edx,ecx                       // copy every digit
  }
Copy:
  __asm {
    mov   eax,[edx*NBYTE+esi-NBYTE]
    mov   [edx*NBYTE+edi-NBYTE],eax
    dec   edx
    jnz   Copy
    mov   edi,this
  }
NEGATE:
  __asm {
    jecxz  RET1               // do nothing if a=0
#ifdef __BORLANDC__
    neg   byte ptr [edi.nDim+3]   // negate signature
#else
    neg   byte ptr [edi+SIGN]
#endif
  }
RET1:
#ifdef _MEMMAN
_MemMan.check(__FILE__,__LINE__) ;
check(__FILE__,__LINE__) ;
#endif
  return *this ;
}

