//
//  Copyright (C) by S.Tomabechi 1995
//  All rights reserved.
//
//  f̍ŏfn( primitive root ) ߂
//
//  p : f ( ̊֐ł, fǂׂȂ )
//  ߂l g : g^(p-1)=1 mod p 𖞂 ŏ̑f g
//             g^n!=1 mod p for n<p-1
//  2 珇ɂ̈ʐ𒲂ׂPȕ@
//
#ifdef __BORLANDC__
#pragma inline
#endif

#include "IntFuncs.hpp"

unsigned long prmrootp(const unsigned long p)
{
  unsigned long n(0) ;
  unsigned long q ;
  __asm {
    cmp p,2
    jne RETRY
    mov p,1
    jmp RET1
  }
RETRY:
  q=prm(++n) ;     // fɋ߂
  __asm{
    mov edi,q
    mov eax,1      // w=1
    mov ebx,p
    mov ecx,ebx    // ecx <- p
    sub ecx,2      // [v̉ p-2
  }
MUL_MOD:
  __asm {          // 1  p-2 ܂ŉ
    xor edx,edx
    mul edi        // w*g
    div ebx        // %p vZ
    mov eax,edx    // w=(w*g)%p
    cmp eax,1      // Pʌ ?
    je  RETRY      // nłȂ, ʐ p-1 łȂ
    dec ecx
    jnz MUL_MOD    //  g Ă݂
    mov p,edi      // g^n!=1 mod p for n<p-1 猴n
  }
RET1:
  return p ;
}
