//
//  Copyright (C) by S.Tomabechi 1998
//  All rights reserved.
//
//  assignment operator of Bit class
//

#ifdef __BORLANDC__
#pragma inline
#endif

#include "TBit.hpp"
#include "Error.hpp"

TBit& TBit::operator=(const TBit& b)
{
  __asm {
    mov  esi,b
    mov  edi,this
    cmp  esi,edi
    je   RET1
#ifdef __BORLANDC__
    mov  ecx,dword ptr [esi.(class TBit)nArray]   // compare array size
    cmp  ecx,dword ptr [edi.(class TBit)nArray]
#else
    mov  ecx,dword ptr [esi+NARRAY]
    cmp  ecx,dword ptr [edi+NARRAY]
#endif
    jg   ERROR
#ifdef __BORLANDC__
    mov  ebx,dword ptr [esi.(class TBit)size]
    mov  dword ptr [edi.(class TBit)size],ebx
    mov  esi,dword ptr [esi.bit]
    mov  edi,dword ptr [edi.bit]
#else
    mov  ebx,[esi+SIZE]
    mov  [edi+SIZE],ebx
    mov  esi,[esi+BIT]
    mov  edi,[edi+BIT]
#endif
    rep  movsd                                    // copy bit strings
    jmp  RET1
  }
ERROR:
  Error(small size) ;                             // error when length(left value)<length(right value)
RET1:
  return *this ;

}