//
//  Copyright (C) by S.Tomabehci 1996
//  All rights reserved.
//
//  _
//   Ԗڂ̃p^̂ƈv
//
//  Mersenne  Lucas @̂ߍĂ݂D
//
#ifndef __cplusplus
#error Must use C++ for the type Mint
#endif

#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

Mint& Mint::isAND(const Mint& a,const Mint& b)
{

  int shift(a.fDigit-b.fDigit) ;
  signed char sign=(signed char)(a.nDim>>24) ;

  if( shift<0 ) {
    __asm {                  // a  b 
      mov   eax,a
      xchg  eax,b
      mov   a,eax
      neg   shift
    }
  }

  int anDigit=a.nDigit ;
  int bnDigit=b.nDigit+shift ;
  int min_a_b=anDigit<bnDigit ? anDigit:bnDigit ;
  min_a_b=(min_a_b>shift ? min_a_b:shift) ;
  bool same=(this==&a) ;
  unsigned long* v ;

  if( this==&b ) {
    (_vMtemp=b).fDigit=0 ;
    v=_vMtemp.digit ;
  }
  else v=b.digit ;

       // ̌ɍ킹
  if( ndim()<min_a_b ) {
    if( same ) reallocate(min_a_b) ;
    else allocate(min_a_b) ;
  }

  __asm {

    mov   edi,this
    mov   esi,a
#ifdef __BORLANDC__
    mov   eax,min_a_b
    mov   [edi.nDigit],eax
    mov   eax,[esi.fDigit]
    mov   [edi.fDigit],eax
    mov   al,[esi.nDim+3]
    mov   [edi.nDim+3],al

    mov   edi,[edi]         // di=offset of digit
    mov   esi,[esi]         // si=offset of a.digit
#else
    mov   eax,min_a_b
    mov   [edi+NDIGIT],eax
    mov   eax,[esi+FDIGIT]
    mov   [edi+FDIGIT],eax
    mov   al,[esi+SIGN]
    mov   [edi+SIGN],al

    mov   edi,[edi]         // di=offset of digit
    mov   esi,[esi]         // si=offset of a.digit
#endif
    mov   ecx,shift
    jecxz SetZero
    cmp   same,0
    jne   SetZero
    cmp   ecx,anDigit
    jae   this_is_Zero

    xor   eax,eax
  }
Copy:                         // shift ̈ʒu܂ 0 pfBO
  __asm {
    mov   [ecx*NBYTE+edi-NBYTE],eax
    dec   ecx
    jnz   Copy
  }
SetZero:
  __asm {
    mov   ebx,v                  // bx=offset of b.digit

    mov   eax,shift
    lea   edi,[edi+eax*NBYTE]
    lea   esi,[esi+eax*NBYTE]
    mov   ecx,min_a_b
    sub   ecx,shift
    jng   SKIP1
    cmp   same,1       // this=&a ł. ʏ
    je    subself                //
    xor   edx,edx
  }
loop1:
  __asm {
    mov   eax,[edx*NBYTE+esi] // a.digit[j+shift]
    and   eax,[edx*NBYTE+ebx] // eax=a.digit[j+shift]-b.digit[j]
    mov   [edx*NBYTE+edi],eax // digit[j+shift]=eax
    inc   edx
    dec   ecx
    jnz   loop1
    jmp   SKIP1
  }
subself:
  __asm {
    mov   esi,ebx
    xor   edx,edx
  }
loop11:                       // digit[j+shift]=digit[j+shift]-b.digit[j]
  __asm {                     // ߂l a 
    mov   eax,[edx*NBYTE+esi]
    and   [edx*NBYTE+edi],eax
    inc   edx
    dec   ecx
    jnz   loop11
  }
SKIP1:
  __asm {
    mov   edi,this
#ifdef __BORLANDC__
    mov   esi,[edi]
#else
    mov   esi,[edi]
#endif

    mov   al,sign
#ifdef __BORLANDC__
    mov  [edi.nDim+3],al
#else
    mov  [edi+SIGN],al
#endif
  }
//not_reverse:
  __asm {
    mov   ecx,min_a_b
    jecxz SET_ZERO
  }
normal:                       // LZbg
  __asm {
    cmp   dword ptr [ecx*NBYTE+esi-NBYTE],0   // 0 ?
    jne   set_digit             // 0 łȂŏʌ
    dec   ecx
    jnz   normal
  }
SET_ZERO:                     // 0 łȂ͂ȂDZʂ́A0 낤.
  __asm {
#ifdef __BORLANDC__
    mov  byte ptr [edi.nDim+3],1
#else
    mov  byte ptr [edi+SIGN],1
#endif
//    mov   dword ptr [esi],0
  }
set_digit:
  __asm {
  }
  __asm {
#ifdef __BORLANDC__
    mov [edi.nDigit],ecx   // cx ͗L
#else
    mov [edi+NDIGIT],ecx   // cx ͗L
#endif
    jmp  RET1
  }
this_is_Zero:
  __asm {
#ifdef __BORLANDC__
    mov dword ptr [esi.nDigit],0
    mov byte ptr [esi.nDim+3],1
#else
    mov dword ptr [esi+NDIGIT],0
    mov byte ptr [esi+SIGN],1
#endif
  }

RET1:
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
#endif
  return *this ;
}
