//
//  Copyright (c) by S.Tomabechi 1993.1994,1995,1996
//     All rights reserved.
//
//  Mint <- Mint
//
//  Zq
//
#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

Mint& Mint::operator=(const Mint& a)
{
#ifdef _MEMMAN_DEBUG
//_MemMan.check(__FILE__,__LINE__) ;
a.check(__FILE__,__LINE__) ;
#endif
  int anDigit ;
  __asm {

    mov edi,this
    mov esi,a
    cmp edi,esi
    je  RET1                 // do nothing when this=&a

#ifdef __BORLANDC__
    mov eax,[esi.nDigit]
    mov anDigit,eax
    mov ebx,[edi.nDim]
#else
    mov eax,[esi+NDIGIT]
    mov anDigit,eax
    mov ebx,[edi+NDIM]
#endif
    and ebx,_DIGITS_
    cmp eax,ebx
    jb  ASSIGN               // not enough memory
  }

  allocate(anDigit) ;       // enlarge array

#ifdef _MEMMAN_DEBUG
_MemMan.check(__FILE__,__LINE__) ;
#endif

  __asm {

    mov   edi,this
    mov   esi,a
  }
ASSIGN:
  __asm {
#ifdef __BORLANDC__
    mov   ecx,[esi.nDigit]
    mov   eax,[esi.fDigit]
    mov   dl,[esi.nDim+3]

    mov   [edi.nDigit],ecx
    mov   [edi.fDigit],eax
    mov   [edi.nDim+3],dl
    jecxz RET1
    mov   esi,[esi]
    mov   edi,[edi]
#else
    mov   ecx,[esi+NDIGIT]
    mov   eax,[esi+FDIGIT]
    mov   dl,[esi+SIGN]

    mov   [edi+NDIGIT],ecx
    mov   [edi+FDIGIT],eax
    mov   [edi+SIGN],dl
    jecxz RET1
    mov   esi,[esi]
    mov   edi,[edi]
#endif

    rep movsd                           // copy digits
  }

RET1:
#ifdef _MEMMAN_DEBUG
_MemMan.check(__FILE__,__LINE__) ;
check(__FILE__,__LINE__) ;
#endif
  return *this ;
}

