//
//  Copyright (C) by S.Tomabechi November 1993
//  All rights reserved.
//
// compute class number enumerating reduced quadratic forms
//
//  Ȗ񎟌`̐ɂ,ސvZ
//
//  킴킴AZuĝ̂ł͂Ȃ
//
#pragma inline
#include <math.h>
#include <iostream.h>
#include <iomanip.h>
#include "IntFuncs.hpp"

unsigned long detectSquare(unsigned long) ;

unsigned long h(unsigned long D)
{
  long h0(1) ;
  long b ;
  long a,sq,B ;
  long qa ;
  long q ;

Check: ;

  if( detectSquare(D) ) goto RET0 ;  // q܂܂Ă

Initialize_b:

  asm {
    mov eax,D
    and eax,3              // mod 4
    cmp eax,3
    je  SQRT               // D=3 mod 4
    shl D,2    // D <- 4*D
  }
SQRT:
  asm {                    // isqrt(D/3) vZ
    mov eax,dword ptr D
    xor edx,edx
    mov ebx,3
    div ebx

    mov edi,eax
    bsr ecx,eax            // n ̃rbg߂
    jz  ZERO
    mov ebx,1
    inc ecx                // l=l+1  l: ñrbg
    shr ecx,1              // l /= 2
    inc ecx                // l++
    shl ebx,cl             // Newton@̏l
  }
SQ_LOOP0:
  asm {
    mov eax,edi
    xor edx,edx
    div ebx                // n/x
    add eax,ebx            // n/x+x
    shr eax,1              // (n/x+x)/2
    cmp eax,ebx
    jae OK0
    mov ebx,eax
    jmp SQ_LOOP0
  }
OK0:
  asm {
    mov dword ptr B,ebx
    jmp EXEC
  }
ZERO:
  asm {
    jmp RET
  }

EXEC:
  asm {
    xor edi,edi
    mov esi,D
    and esi,1             // esi=D mod 2
  }
LOOP0:
  asm {                    // sqrt(q)
    mov eax,esi
    mul esi
    add eax,D
    adc edx,0
    mov ecx,4
    div ecx
    mov  q,eax

    bsr ecx,eax            // n ̃rbg߂
    mov ebx,1
    inc ecx                // l=l+1  l: ñrbg
    shr ecx,1              // l /= 2
    inc ecx                // l++
    shl ebx,cl             // Newton@̏l
  }
SQ_LOOP:
  asm {
    mov eax,dword ptr q
    xor edx,edx
    div ebx                // n/x
    add eax,ebx            // n/x+x
    shr eax,1              // (n/x+x)/2
    cmp eax,ebx
    jae OK
    mov ebx,eax
    jmp SQ_LOOP
  }
OK:
  asm {
    mov ecx,ebx
  }
Zero:
  asm {


    mov  ebx,esi
    cmp  ebx,1
    jae  LOOP_1
    mov  ebx,1

  }
LOOP_1:
  asm {

    cmp ebx,ecx           // a<=sq ?
    ja  INC_b
    mov eax,dword ptr q   // ecx=q
    xor edx,edx
    div ebx               // q/a
    cmp edx,0             // q%a=0 ?
    jne INC_a
    cmp ebx,esi           // a=b ?
    je  INC_h
    mov eax,ebx
    mul ebx
    cmp eax,dword ptr q   // a*a=q ?
    je  INC_h
    cmp esi,0             // b=0 ?
    je  INC_h
    inc edi
  }
INC_h:
  asm {
    inc edi
  }
INC_a:
  asm {                   // a++
    inc ebx
    jmp LOOP_1
  }

INC_b:
  asm {
    add esi,2             // b += 2
    cmp esi,dword ptr B
    ja  RET
    jmp LOOP0
  }



RET:
  asm mov dword ptr h0,edi
  return h0 ;
RET0:
  return 0 ;
}

/********************
long h(long D)
{
 long h0 ;
 long b ;
 long a,q,sq,B ;
 long qa ;

Check: ;
Initialize_b:

  if( ((unsigned long)D)&1 ) b=1 ;
  else      b=0 ;

  B=sqrt(fabs(double(D))/3.0) ;

Initialize_a:
  h0=0 ;
  for( ; b<=B ; b += 2 ) {
    q=(b*b-D)/4 ;
    a=b ;
    if( a<=1 ) a=1 ;
    sq=sqrt(double(q)) ;
    for( ; a<=sq ; a++ ) {
Test: ;

      if( q%a==0 ) {
        if( a==b || a*a==q || b==0 ) h0++ ;
        else h0 += 2 ;
      }
Loop_on_a: ;

      }
Loop_on_b: ;

  }

  return h0 ;
}
************************/

