//
//  Copyright (C) by S.Tomabechi 1994,1995
//  All rights reserved.
//
//  return small divisor
//
//   return valuse : small divisor if exists
//                   0   when has big prime divisor
//                   1   when is a prime
//
#include "Mint.hpp"
extern const unsigned char _t_[] ;
extern const unsigned char _small_prime_[] ;

//Mint isqrt(Mint& n) ;

unsigned long prmdiv2(const unsigned long n1,const unsigned long n0,const unsigned long MAX_DIVISOR)
{

  unsigned long divisor ;
                                              
  if( n1==0 ) return prmdiv((unsigned long)n0) ;  

  __asm {
    xor edi,edi
  }
SMALL:
  __asm {
    movzx ebx,byte ptr [_small_prime_+edi]

    xor edx,edx
    mov eax,n1
    div ebx
    mov eax,n0
    div ebx
    or  edx,edx
    jz  FOUND

    inc edi
    cmp edi,5
    jb  SMALL

    mov edi,MAX_DIVISOR
    mov esi,47
    jmp NEXT
  }

TRY_DIV:
  __asm {
    cmp ebx,edi
    ja  RET_9
    xor edx,edx
    mov eax,n1
    div ebx
    mov ecx,eax
    mov eax,n0
    div ebx
    or  edx,edx
    jz  FOUND
    or  ecx,ecx
    jnz NEXT
    cmp eax,ebx
    jb  PRIME
  }
NEXT:
  __asm {
    inc esi
    cmp esi,48
    jne NEXT1
    xor esi,esi
  }

NEXT1:
  __asm {
    movzx ecx,byte ptr [_t_+esi]
    add   ebx,ecx
    jmp TRY_DIV
  }

FOUND:
  __asm {
    mov divisor,ebx
    jmp RET1
  }
PRIME:
  __asm {
    mov divisor,1
    jmp RET1
  }

RET_9:
  __asm {
    mov divisor,0
    jmp RET1
  }
RET1:
  return divisor ;


}

