//
//		Copyright (C) by S.Tomabechi 2001
//		All rights reserved.
//
//		represent an odd prime by sum of squares (Euler)
//

#include "Mint.hpp"


bool SumSquare(Mint& p,Mint& X,Mint& Y)
{
	Mint x,y ;
	Mint n ;
	Mint alpha,beta ;
	Mint a,b ;
	Mint N ;

//	if( p<0 ) return false ;
//	else if( (long(p)&3)!=1 ) return false ;
	cout << endl << "prime " << p ;
	if( (long(p)&3)!=1 ) return false ;

	if( Kronecker(p-1,p)!=1 ) return false ;  // (-1/p)=1 ?

	X=sqrt((p-1),p) ;

	Y=1 ;
	while( X*X+Y*Y>p ) {
cout << endl << "X Y " << X << " " << Y ;

		x=amod(X,p) ;
		y=amod(Y,p) ;
		n=x*x+y*y ;
		n/=p ;
		if( n==1 ) {
			X=x ;
			Y=y ;
			return true ;
		}
		else {
			a=amod(x,n) ;
			b=amod(y,n) ;
			alpha=(x-a)/n ;
			beta=(y-b)/n ;
			N=(a*a+b*b)/n ;
			X=N+a*alpha+b*beta ;
			if( sign(X)<0 ) ~X ;
			Y=a*beta-b*alpha ;
			if( sign(Y)<0 ) ~Y ;
		}
	}


}


#include <stdlib.h>

int main(void)
{
	unsigned long p ;
	Mint P ;
	Mint x,y ;

	for( ; ; ) {
		cout << "input a number " ;
		cin >> p ;
		if( p==0 ) break ;
		p=nextprm(p) ;
		P=p ;
		if( SumSquare(P,x,y) ) {
			cout << endl << P << " " << x*x << " + " << y*y ;
		}
		else cout << endl << "failed " ;
	}
	return 1 ;

}