//
//	Elliptic Curve over Rational Number Field  0.10
//
//	Copyright (C) 2001	by S.Tomabechi
//		 All rights reserved
//
//	  y^2 = x^3 + ax + b 
//
#ifndef __cplusplus
#error Must use C++ for the type Fint
#endif


#ifndef __EQ_HPP
#define __EQ_HPP

#include "Mint.hpp"
#include "Rational.hpp" 
#ifdef __BORLANDC__
#	 pragma warn -lvc
#endif

class EQ {
public:
	EQ() {}	
	EQ(const Rational& _a,const Rational& _b) {
		a=_a ;
		b=_b ;
		
	}
private: 
	Rational a ;
	Rational b ;
	
} ;
	
#endif
