//
//  Copyright (c) by S.Tomabechi 1995
//  All rights reserved.
//  
//  ~\
//
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>
#include "Fint.hpp"
#include "CPUTime.hpp"
#include "MintFunc.hpp"

int main(void)
{
  SetFormat(digit5) ;
  SetPrecision(1) ;
  Fint _pi ;
  CPUTime cputime,cpu ;
  long precision ;

  for(;;) {
    cout << endl << " Input precision (Input 0 to exit) " ;
    cin >> precision ;
    if( precision<=0 ) break ;
    precision=double(precision)/(4*2.40824)+1 ;
    if( precision==0 ) precision=1 ;
    cputime.Start() ;
    _pi=pi(precision) ;
    cputime.Stop() ;
    cout << endl << _pi ;
    cout << endl << "cputime " << cputime ;
    cputime.Reset() ;
  }
RET: ;
  return 0 ;
}