//
//  Copyright (C) by S.Tomabechi 1993,1994,1995
//  All rights reserved.
//
//  comparison of integer and unsinged long integer
//
//  CX^X͍̕lAΒlŔr(悤ύX 1995.05.30)
//
//  1998/03/18
//    *this=0 ̏ꍇ 召֌Wt]Ă
//
#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

//
// return value  1 abs(*this)>n
//               0 *this=n
//              -1 abs(*this)<n
//

int Mint::compareUL(const unsigned long n) const
{
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
#endif
  int sign(1) ;

  __asm {
    mov   ebx,n
    mov   esi,this
#ifdef __BORLANDC__
    cmp   dword ptr [esi.nDigit],1  // #digits > 1 ?
#else
    cmp   dword ptr [esi+NDIGIT],1
#endif
    jg    Great                     // #digits >= 2
    je    DIGIT1                    // #digits = 1
  }
                                    // is *this=0 ?

  __asm {                           // case *this=0
    or   ebx,ebx                    // is n also 0
    jz   Equal
    jmp  Less                       // *this=0 n!=0
  }

DIGIT1:
  __asm {

#ifdef __BORLANDC__                 // #digits=1 and *this!=0
    mov   esi,[esi]
#else
    mov   esi,[esi]
#endif
    cmp   [esi],ebx              // compare digit[0] and n
    ja    Great                  // digit[0] > n
    jb    Less                   // digit[0] < n
  }

Equal:
  __asm {
    mov   sign,0                    // is equal
    jmp   RET1
  }
Less:
  __asm neg sign
Great:
RET1:
  return sign ;

}

