//
//	Copyright (C) by S.Tomabechi. 1993,1997
//	All rights reserved.
//
//	inverse
//
#ifdef __BORLANDC__
#pragma inline
#endif

#include "Fint.hpp"
#include <math.h>
#include "Error.hpp"

Fint inverse(const Mint& a)
{
  int precision=a.ndigit()	;
//	precision<<=1 ;
//	precision+=10 ;
  precision=SetPrecision(precision) ;
  Fint fa=a ;
  fa=inverse(fa) ;
  SetPrecision(precision) ;
//	fa[precision-fa.fdigit()] ;
  return fa ;

}


Fint& Fint::isInverse(const Fint& a)
{
  int anDigit ;
  int afDigit ;
  int shift ;
  int precision ;
  int t(3+a.nDigit/100) ;		   // xۂ߂ɗ鉺
  Fint* aa ;
  bool same(false) ;

//	t=(a.nDigit-a.fDigit)>t ? (a.nDigit-a.fDigit):t ;

  __asm {
	mov	 esi,a
	cmp	 esi,this
	sete same
	mov	 aa,esi
#ifdef __BORLANDC__
	mov eax,[esi.nDigit]
	or	eax,eax
	jz	this_is_Zero
	mov anDigit,eax
	mov ecx,[esi.fDigit]
	add eax,t
	mov [esi.fDigit],eax	// =0 ̎ɕϊ
	mov afDigit,ecx
	mov precision,eax
	sub eax,ecx
	mov shift,eax					  // 炵_̌
#else
	mov eax,[esi+NDIGIT]
	or	eax,eax
	jz	this_is_Zero
	mov anDigit,eax
	mov ecx,[esi+FDIGIT]
	add eax,t
	mov [esi+FDIGIT],eax
	mov afDigit,ecx
	mov precision,eax
	sub eax,ecx
	mov shift,eax					 // shift=a.nDigit-a.fDigit-1
#endif
	jmp EXECUTE
  }
this_is_Zero:
  Error(number is zero) ;


EXECUTE:
  Fint s ;
Fint ss ;
  if( same ) {				 // ߂lƃp^v
	aa=&Fint::_vFtemp ;		 // p^Rs[
	*aa=a ;
  }
  else {
	aa=&((Fint&)a) ;
  }
  if( anDigit+t<=FFT_digit ) {
	isDiv(1UL,*aa) ;
  }
  else {
	((Mint*)this)->isShift32((Mint&)(*aa),FFT_digit-anDigit-1) ;
//	((Mint*)this)->isShift32((Mint&)(*aa),FFT_digit-anDigit) ;
	isDiv(1UL,*this) ;
	((Mint*)this)->isShift32((Mint&)(*this),precision-fDigit) ;

//cout << endl << "this " << (*this) ;
//cout << endl << "a " << (*aa) ;
	for(;;) {
	  s.isMulF(*this,*aa) ;
//cout << Int(s) << " "	 << flush ;
#if 1
	 ~s ;
	 ++s ;
//cout << endl << s ;
#else
ss=s ;
	 ~s ;
//	 ++s ;
s++ ;
	 ~ss ;
	 ss++ ;
cout << endl << s ;
if( s!=ss ) {
cout << endl << "ss " << endl << ss ;
	Error(s!=ss) ;
}
#endif
	  if( s.nDigit<t )break ;
	  else { s.isMulF(*this,s) ; isAdd(*this,s) ; }
	}
  }
//cout << endl << "this " << (*this) ;

			  // a Ƃ̒lɖ߂
  if( !same ) {
	__asm {
	  mov esi,a
	  mov eax,afDigit
#ifdef __BORLANDC__
	  mov [esi.fDigit],eax
#else
	  mov [esi+FDIGIT],eax
#endif
	}
  }

  fDigit+=shift ;

  return (Fint&)((Mint*)this)->isShift32((Mint&)(*this),afDigit-fDigit) ;
}
