//
//  Copyright (C) by S.Tomabechi 1993
//  All rights reserved.
//
//  generate random number
//
//  c.f. "Numerical Recipes in C" 2-nd edition p284 (ranqd1)
//
//  (ǂ)𔭐
//
#ifdef __BORLANDC__
#pragma inline
#endif


extern unsigned long random_seed ;
unsigned long irandom(unsigned long& Xn)
{
#ifndef __BORLANDC__
  unsigned long r ;
#endif
  __asm {

    mov   esi,Xn

    mov   ecx,1664525
    mov   eax,[esi]
    mul   ecx
    add   eax,1013904223

    mov   [esi],eax
#ifndef __BORLANDC__
    mov   r,eax
#endif
  }

#ifdef __BORLANDC__
  return _EAX ;
#else
  return r ;
#endif
}


