//
//  Copyright (C) by S.Tomabechi 1994
//  All rights reserved.
//
//  memory manager for debug
//
//  this routine is not fast
//
#include "MemMan.hpp"

#include <iostream.h>
#include <iomanip.h>
inline long min(long a,long b)
{
  return a>b ? b:a ;
}
//#pragma inline

unsigned long MemMan::nalloc=0 ;
unsigned long MemMan::nfree=0 ;
unsigned long MemMan::nBlock=0 ;

// destructor
MemMan::~MemMan() {
debug() ;
  MemBlock* pBlock=availBlock ;
  MemBlock* qBlock ;
  do {
    qBlock=pBlock->pBlock ;
    delete pBlock ;
    pBlock=qBlock ;
  } while( pBlock!=availBlock ) ;
cout << endl << "#alloc " << nalloc ;
cout << endl << "#free  " << nfree ;
cout << endl << "#Block " << nBlock ;
}

//////////////////////////////////////////////////
//
//  nByte : 蓖ėvoCg
//
void* MemMan::alloc(long nByte)
{
nalloc++ ;
//debug() ;
//check() ;
  long nunits ;
  Mem* pMem ;
  MemBlock* pB ;
  MemBlock* pB0 ;


  nunits=(nByte+3)/4+1 ;

  pB0=pB=availBlock ;       // ݃ANeBuȃubN
  do {
    pMem=pB->alloc(nunits) ;
    if( pMem ) {
      availBlock=pB ;
      return (void*)pMem ;
    }
    else  pB=pB->pBlock ;   // 蓖ĂɎŝŁÃubN
                            // Ɋ蓖Ăv
  } while( pB0!=pB ) ;      // ׂẴubNǂ ?

//cout << endl << "size " << nByte ;
//debug() ;
                            // ׂẴubNŊ蓖ĂɎs
  newBlock() ;              // VubN쐬

  return (void*)(availBlock->alloc(nunits)) ;

}

///////////////////////////////////
//
//  VubN쐬
//
void MemMan::newBlock()
{

nBlock++ ;

  MemBlock* nBlock=new MemBlock(BLOCK_SIZE) ;
  if( !nBlock || !(nBlock->pMem) ) {
    debug() ;
    Error( new Block allocate error ) ;
  }
  if( availBlock ) {
    nBlock->pBlock=availBlock->pBlock ;  // ubÑ`FCeiX
    availBlock->pBlock=nBlock ;          // `FC͊ɂȂ
    availBlock=nBlock ;
  }
  else {                                 // ߂ăubN쐬
    availBlock=nBlock ;
    availBlock->pBlock=nBlock ;          // ̃ubNgɂ
  }
}

///////////////////////////////////
//
//  󂫃𕹍
//
void MemBlock::merge()
{
  Mem* p ;
  Mem* q ;
  for( p=pMem ;; ) {
    if( p->size<0 ) p += -(p->size ) ;   // gp
    else if( p->size==0 ) break ;        // ubN̏I[
    else {
Try_more: ;
      q=p+(p->size) ;
      if( q->size>0 ) {                  // A󂫃
        p->size += q->size ;             // 
        goto Try_more ;                  // ɕ݂
      }
      else if( q->size<0 ) {             // gp̂߂͂╹łȂ
        p += p->size ;
        continue ;
      }
      else break ;                       // ubN̏I[
    }
  }

  availMem=pMem ;
//cout << endl << "post merge " ;
//debug() ;
}

Mem* MemBlock::alloc(long nunits)
{

//merge() ;
//check(BLOCK_SIZE) ;
  bool merged=false ;
  Mem* nMem=availMem ;
  Mem* qMem ;


  for(;;) {
    if( nMem->size>=nunits ) {       // vꂽTCYɏ\ȋ󂫂
      if( nMem->size==nunits ) {     // 傫̋
        nMem->size=-nunits ;         // gpɂ
        availMem=nMem ;
        return availMem+1 ;
      }
      else {                         // vTCY傫
        qMem=nMem+nunits ;
        qMem->size=nMem->size-(nunits) ;
        nMem->size=-nunits ;         // gpɂ
        availMem=nMem ;
        return availMem+1 ;
      }
    }
    else {                           // ̋󂫂𒲂ׂ
      if( nMem->size>0 ) nMem += (nMem->size) ;
      else if( nMem->size<0 ) nMem += -(nMem->size) ;
      else {
        if( !merged ) {              // I[܂ŒHĂ܂
          merge() ;                  // Ƃ肠ċ󂫂
          merged=true ;
          nMem=this->availMem ;
        }
        else return NULL ;           // 󂫗̈𕹍ĂA\
                                     // 傫̋󂫂͓Ȃ
      }
    }
  }

}

////////////////////////////
//
//  ubNɖ߂
//

void MemMan::free(void* p) {       // ubNɖ߂
  Mem* q=(Mem*)p-1 ;
  q->size=-(q->size) ;

nfree++ ;
}


void MemMan::debug()
{
  MemBlock* pBlock=availBlock ;
  cout << endl << " *************  memory map ************** " ;
  cout << endl << "Block      " << hex << availBlock->pMem ;
  cout << endl << "next Block " << hex << availBlock->pBlock->pMem ;
  do {
    pBlock->debug(BLOCK_SIZE) ;
    pBlock=pBlock->pBlock ;
  } while( availBlock!=pBlock ) ;
  cout << dec ;
}

long MemMan::check(char* file,int line)
{

  long byte(0) ;
#ifdef _MEMMAN_DEBUG
//if( (*(unsigned long*)0)!=0 ) {
//debug() ;
//Error(Null pointer assignement) ;
//}

  MemBlock* pBlock=availBlock ;
  long rc ;
  do {
    rc=pBlock->check(BLOCK_SIZE) ;
    if( rc<0 ) {
      cout << endl << file << " " << line ;
      Error(Broken memory) ;
    }
    byte += rc ;
    pBlock=pBlock->pBlock ;
  } while( availBlock!=pBlock ) ;
#endif
  return byte ;
}

//
// ubN̓e\
//
void MemBlock::debug(long BLOCK_SIZE)
{
  int j ;
  Mem* p ;
  unsigned long* lp ;
  long byte(0) ;
//  cout << endl << "availeMem " << hex << availMem ;
  for( p=pMem ;; ) {
    cout << endl << hex << p
         << '(' << dec << setfill(' ') << setw(5)
         << (unsigned long)(p-pMem) << ')'
         << ":" << setw(5) << p->size
         << '(' << setw(5) << 4*(p->size) << ')' ;
    cout << hex ;
    lp=(unsigned long*)p ;
    for( j=0 ; j<min(abs(p->size),10L) ; j++ )
      cout << " " <<  *(lp+j) ;
    cout << dec ;
    if( p->size > 0 ) p += p->size ;
    else if( p->size<0 ) {
      byte += (-(p->size)) ;
      p += -(p->size) ;
    }
    else break ;
    if( 4*(p-pMem)>BLOCK_SIZE ) Error( exceed range ) ;

  }
  cout << endl << " next Memory Block " << hex << pBlock->pMem ;
  byte<<=2 ;
  cout << endl << " used " << dec << byte << " bytes" ;
//  return byte ;
}

long MemBlock::check(long BLOCK_SIZE)
{
  long byte(0) ;
#ifdef _MEMMAN_DEBUG
  Mem* p ;
//  cout << endl << "availeMem " << hex << availMem ;
  for( p=pMem ;; ) {
//    cout << endl << hex << p << ":" << dec << p->size ;
    if( p->size > 0 ) p += p->size ;
    else if( p->size<0 ) {
      byte += (-(p->size)) ;
      p += -(p->size) ;
    }
    else break ;
    if( 4*(p-pMem)>BLOCK_SIZE ) {
//debug(BLOCK_SIZE) ;
      cout << endl << (p-pMem) ;
      cout << endl << BLOCK_SIZE << flush ;
      return -999 ;
//      Error( exceed range ) ;
    }
  }
  byte<<=2 ;
  if( 4*(p-pMem)!=(BLOCK_SIZE-4) ) {
debug(BLOCK_SIZE) ;
    cout << endl << (p-pMem) ;
    cout << endl << BLOCK_SIZE << flush  ;
    return -999 ;
//    Error(leak memery) ;
  }
#endif
  return byte ;
}

