//
//  Copyright (C) by S.Tomabechi.1994
//  All rights reserved.
//
// return the smallest prime number which are bigger than given n
//
//
//  ^ꂽ d 傫fōŏ̑f.
//  AȐɂĂ̂ݗL
//
#ifdef __BORLANDC__
#pragma inline
#endif

extern const unsigned char _t_[] ;
extern const unsigned char _small_prime_[] ; // ={2,3,5,7,11}

unsigned long nextprm(const unsigned long n)
{

  __asm {
    mov   ebx,n            // fix ebx <- n
    cmp   ebx,10           // n>10 ?
    ja    Great
    xor   esi,esi          // n is small
  }
SMALL_LOOP:                // one of 2,3,5,7,11
  __asm {
    movzx ecx,byte ptr [_small_prime_+esi]

    cmp   ebx,ecx
    jb    Set_small
    inc   esi
    cmp   esi,5
    jb    SMALL_LOOP
  }
Set_small:
  __asm {
    mov   ebx,ecx
    jmp   PRIME
  }
Great:                   // greater than 13
  __asm {
    mov   edi,ebx
    mov   eax,ebx        // compute (n-11)/210*210+11
    xor   edx,edx
    mov   ecx,210
    sub   eax,11
    div   ecx
    mul   ecx
    add   eax,11
    mov   ebx,eax        // ebx <- (n-11)/210*210+11
    mov   esi,47
  }
SearchLoop:
  __asm {
    inc   esi
    cmp   esi,48
    jb    SKIP
    xor   esi,esi
  }
SKIP:
  __asm {
    movzx edx,byte ptr [_t_+esi]

    add   ebx,edx
    cmp   ebx,edi      // loop while ebx<n ebx>n
    jbe   SearchLoop
  }

LOOP0:                 // look for prime
  __asm {              //
    mov   edi,1        // divide by 3
  }
MoreDivide:
  __asm {
    mov   eax,ebx
    xor   edx,edx
    movzx ecx,byte ptr [_small_prime_+edi]

    div   ecx
    or    edx,edx
    jz    FACTOR
    inc   edi
    cmp   di,5
    jl    MoreDivide

    mov   edi,47
  }
LOOP1:
  __asm {                // divide by odd numbers whichi are greater than 13
    inc   edi
    cmp   di,48
    jne   SKIP1
    xor   edi,edi
  }
SKIP1:
  __asm {
    movzx edx,byte ptr [_t_+edi]

    add   ecx,edx      // 傫
    mov   eax,ebx
    xor   edx,edx
    div   ecx
    cmp   eax,ecx      // quotient < divisor ?
    jb    PRIME        // found a prime
    or    edx,edx
    jz    FACTOR       // remainder = 0
    jmp   LOOP1        // divide by next divisor
  }
FACTOR:
  __asm {
    inc   esi           // is not prime. try for next integer.
    cmp   si,48
    jne   SKIP2
    xor   esi,esi
  }
SKIP2:
  __asm {
    movzx edx,byte ptr [_t_+esi]
    add   ebx,edx
    jmp   LOOP0
  }

PRIME:
#ifdef __BORLANDC__
  __asm mov eax,ebx
  return _EAX ;
#else

  __asm mov n,ebx
  return n ;
#endif

}
