//
//	Copyright (C) by S.Tomabechi 1993,1997
//	All rights reserved.
//
//	calculate power mod p  x^n mod p
//
//	1997/05/30
//	   pŵƂ́Amod p ł̋t̙pvZ悤ɂ
//
//	  &x=&n 邢 &x=&p łĂ͂ȂȂ
//
#include "Mint.hpp"
#include "Error.hpp"

Mint& Mint::power(const Mint& x,const Mint& n,const Mint& p)
{

  long j(0),k ;
  unsigned long d ;
  long leng=ilog2(n) ;

  if( !n.isNegative() ) Mint::_uuMtemp=x ;	 // n>=0
  else {
//	  Mint::_uuMtemp.isInvModp(x,p) ;		   // inverse x^-1 mod p
	Mint::_uuMtemp=invmodp(x,p) ;
	if( Mint::_uuMtemp.isZero() ) Error(x is zerodivisor) ;
  }

		 // this=&x ̏ꍇ̂ x Rs[Ƃ 1 Zbg
#ifdef WIN32
  __asm {							   // *this <- 1
	mov esi,this
	mov eax,1
  #ifdef __BORLANDC__
	mov [esi.nDigit],eax
	mov [esi.nDim+3],al
	mov esi,[esi]
	mov [esi],eax
  #else
	mov [esi+NDIGIT],eax
	mov [esi+SIGN],al
	mov esi,[esi]
	mov [esi],eax
  #endif
  }
#else
  nDim&=_POSITIVE_ ;
  nDigit=1 ;
  *digit=1 ;
#endif

  if( leng>=0 ) for(;;) {
	d=n.digit[j++] ;
	for( k=32 ; k!=0 ; k-- ) {
	  if( d&1 )
		(*this*=Mint::_uuMtemp)&=p ;  // ŏ]
	  if( --leng<0 ) goto RET1 ;
	   d>>=1 ;
	  Mint::_uuMtemp.isSquare(Mint::_uuMtemp)&=p ;
	}
  }
RET1: ;
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
//_MemMan.check(__FILE__,__LINE__) ;
#endif
  return *this ;

}

