//
//  Copyright (C) by S.Tomabechi 1994,1995,1997
//  All rights reserved.
//
//  round real number
//
//  _ȉ n Ɋۂ(ľܓ)Ǎʂ_ȉ n ̐
//  ؂̂ĂD
//
#ifdef __BORLANDC__
#pragma inline
#endif

#ifndef __cplusplus
#error Must use C++ for the type Fint
#endif

#define _ONLY_MINTDECL_
#define _ONLY_FINTDECL_
#include "Fint.hpp"
#include "Error.hpp"

//
// n : precision required
//
Fint& Fint::isRound(const Fint& a,const int n)
{
#ifdef _MEMMAN_DEBUG
a.check(__FILE__,__LINE__) ;
#endif

  if( n<0 ) Error(n must be positive) ;

  int anDigit ;
  int bnDigit ;
  int afDigit ;
  bool same ;

  __asm {
    mov  esi,a
    mov  edi,this
    cmp  esi,edi
    sete same
#ifdef __BORLANDC__
    mov  eax,[esi.nDigit]
    mov  edx,[esi.fDigit]
#else
    mov  eax,[esi+NDIGIT]
    mov  edx,[esi+FDIGIT]
#endif
    mov  anDigit,eax
    mov  afDigit,edx
    add  eax,n
    sub  eax,afDigit          // lenth of result
    js   this_is_Zero
    mov  bnDigit,eax
#ifdef __BORLANDC__
    mov  ebx,[edi.nDim]
#else
    mov  ebx,[edi+NDIM]
#endif
    and  ebx,_DIGITS_
    cmp  eax,ebx
    jb   EXECUTE
  }

                                    // enlarge array by 1 digit
  if( same ) reallocate(bnDigit+1) ;
  else allocate(bnDigit+1) ;

  __asm {
    mov  esi,a
    mov  edi,this
  }
EXECUTE:
  __asm {
#ifdef __BORLANDC__
    mov  ebx,n
    mov  [edi.fDigit],ebx
    mov  eax,afDigit
    sub  eax,ebx                          // afDigit-n

    mov  ecx,bnDigit
    mov  [edi.nDigit],ecx

    mov  dl,[esi.nDim+3]
    mov  [edi.nDim+3],dl

    mov  esi,[esi]
    mov  edi,[edi]
#else
    mov  ebx,n
    mov  [edi+FDIGIT],ebx
    mov  eax,afDigit
    sub  eax,ebx

    mov  ecx,bnDigit
    mov  [edi+NDIGIT],ecx

    mov  dl,[esi+SIGN]
    mov  [edi+SIGN],dl

    mov  esi,[esi]
    mov  edi,[edi]
#endif
    sub   ebx,afDigit   // ̌傫Ŋۂ߂悤ƂĂ ?
    jbe   MOVE0
  }
SET_ZERO:
  __asm {               // ƂƂȂʂ  pfBO
     mov dword ptr [ebx*NBYTE+edi-NBYTE],0
     dec ebx
     jnz SET_ZERO
  }
MOVE0:
  __asm {
    or   eax,eax
    jge  OK              // Ƃ _ȉ n ȏ゠ꍇ
    neg  eax
    lea  edi,[edi+eax*NBYTE]
    mov  ecx,anDigit
    jecxz this_is_Zero
    xor  ebx,ebx
    xor  edx,edx
    jmp  ADD_LOOP
  }
OK:
  __asm {
    lea  esi,[esi+eax*NBYTE]

    xor  ebx,ebx
    xor  edx,edx
    or   eax,eax
    jle  MOVE_ADD        // Ƃ̌Ɗۂ߂錅
    mov  edx,[esi-NBYTE]  // ľܓl

  }
MOVE_ADD:
  __asm {
    add   edx,0x80000000   // add a half(0.5)
    jecxz Overflow         // _ȉ 0 Ɋۂ߂悤ƂĂ
  }
ADD_LOOP:
  __asm {                  // ۂ߂ȂRs[
    mov  eax,[ebx*NBYTE+esi]
    adc  eax,0
    mov  [ebx*NBYTE+edi],eax
    lea  ebx,[ebx+1]
    dec  ecx
    jnz  ADD_LOOP
  }
Overflow:
  __asm {
    jnc  RET1              // オȂ

                           // オ肪
    mov  dword ptr [ebx*NBYTE+edi],1
    mov  esi,this
#ifdef __BORLANDC__
    inc  dword ptr [esi.nDigit]    //  1 ₷
#else
    inc  dword ptr [esi+NDIGIT]
#endif
    jmp  RET1
  }

this_is_Zero:                 // Lꂽ
  __asm {                     // *this <- 0
    mov  esi,this
    mov  eax,n
#ifdef __BORLANDC__
    mov  dword ptr [esi.nDigit],0
    mov  [esi.fDigit],eax
    mov  byte ptr [esi.nDim+3],1
#else
    mov  dword ptr [esi+NDIGIT],0
    mov  [esi+FDIGIT],eax
    mov  byte ptr [esi+SIGN],1
#endif
  }
RET1:

#ifdef _MEMMAN_DEBUG
_MemMan.check(__FILE__,__LINE__) ;
check(__FILE__,__LINE__) ;
#endif

  return *this ;

}

