//
//  Copyright (C) by S.Tomabechi 1994,1995
//  All rights reserved.
//
//  exchange multiple precision integers
//

#ifdef __BORLANDC__
#pragma inline
#endif
#define _ONLY_MINTDECL_
#include "Mint.hpp"

void Swap(Mint& a,Mint& b)
{
  __asm {
    mov   esi,a
    mov   edi,b
    cmp   esi,edi
    je    RET1
#ifdef __BORLANDC__
    mov   eax,[esi]
    xchg  eax,[edi]
    mov   [esi],eax

    mov   eax,[esi.nDigit]
    xchg  eax,[edi.nDigit]
    mov   [esi.nDigit],eax

    mov   eax,[esi.fDigit]
    xchg  eax,[edi.fDigit]
    mov   [esi.fDigit],eax

    mov   eax,[esi.nDim]
    xchg  eax,[edi.nDim]
    mov   [esi.nDim],eax
#else
    mov   eax,[esi+NDIM]
    xchg  eax,[edi+NDIM]
    mov   [esi+NDIM],eax

    mov   eax,[esi+NDIGIT]
    xchg  eax,[edi+NDIGIT]
    mov   [esi+NDIGIT],eax

    mov   eax,[esi+FDIGIT]
    xchg  eax,[edi+FDIGIT]
    mov   [esi+FDIGIT],eax

    mov   eax,[esi]
    xchg  eax,[edi]
    mov   [esi],eax
#endif
  }

RET1: ;
}

