//
//  Copyright (C) by S.Tomabechi 1993-1997
//  All rights reserved.
//
//  addition of multiple precision integers
//  this routine is valid even for this=&a , this=&b or &a=&b
//
//  @ (_ʒulɓ)
//
//  ϐ const ƂĂ邪A const ł͂Ȃ.
//  CCAZu̕ŁA肻̒l
//  ωAƂɖ߂ꍇ.A
//  ĂԊ֐ɂ͉e^Ȃ.
//  ̊֐Ƃ݂̂ const ͂Ƃ͂łȂ
//

#ifdef __BORLANDC__
#pragma inline
#endif

#ifndef __cplusplus
#error Must use C++ for the type Mint
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

Mint& Mint::isAdd(const Mint& a,const Mint& b)
{
#ifdef _MEMMAN_DEBUG
Mint::_MemMan.check(__FILE__,__LINE__) ;
a.check(__FILE__,__LINE__) ;
b.check(__FILE__,__LINE__) ;
#endif

  __asm {
    mov esi,a
    mov edi,b
#ifdef __BORLANDC__
    mov bl,[edi.nDim+3]
    cmp [esi.nDim+3],bl       // same sign
#else
    mov bl,byte ptr [edi+SIGN]
    cmp byte ptr [esi+SIGN],bl
#endif
    je  SAME_SIGN
#ifdef __BORLANDC__
    neg byte ptr [edi.nDim+3]          // b <- -b
#else
    neg byte ptr [edi+SIGN]
#endif
  }

  isSub(a,b) ;                          // calculate a-(-b)

  __asm {
    mov edi,b
    cmp edi,this                        // this=&b ?
    je  RET1
#ifdef __BORLANDC__
    neg byte ptr [edi.nDim+3]          // reset sign
#else
    neg byte ptr [edi+SIGN]
#endif
    jmp RET1
  }

SAME_SIGN:
  int shift ;
  int anDigit ;
  int bnDigit ;
  bool same ;
  bool Cflag(false) ;
  unsigned long* v ;

  __asm {
#ifdef __BORLANDC__
    mov  eax,[esi.fDigit]
    sub  eax,[edi.fDigit]
#else
    mov  eax,[esi+FDIGIT]
    sub  eax,[edi+FDIGIT]
#endif
    mov  shift,eax
    or   eax,eax
    jge  NOT_EXCHANGE
  }
                          // exchange a and b if shift<0
  __asm {                 // so that length(fraction of a) >
    xchg  a,edi           //          length(fraction of b)
    xchg  b,esi
    neg   shift
  }
NOT_EXCHANGE:
  __asm {
#ifdef __BORLANDC__
    mov  eax,[esi.nDigit]
    mov  ebx,[edi.nDigit]
#else
    mov  eax,[esi+NDIGIT]
    mov  ebx,[edi+NDIGIT]
#endif

    mov  anDigit,eax
    add  ebx,shift
    mov  bnDigit,ebx
    cmp  esi,this
    sete same
  }

  int min_a_b=anDigit<bnDigit ? anDigit:bnDigit ;
  min_a_b=(min_a_b>shift ? min_a_b:shift) ;
  int max_a_b=anDigit>bnDigit ? anDigit:bnDigit ;
  int max_min=max_a_b-min_a_b ;

  if( this==&b) {
    (Mint::_vMtemp=b).fDigit=0 ; // copy b
    v=Mint::_vMtemp.digit ;
  }
  else v=b.digit ;

  if( ndim()<max_a_b+1 ) {              // enough memory ?
    if( same ) reallocate(max_a_b+1) ;  // enlarge array
    else allocate(max_a_b+1) ;
  }

  __asm {

    mov   edi,this
    mov   esi,a
#ifdef __BORLANDC__
    mov   eax,max_a_b
    mov   [edi.nDigit],eax
    mov   eax,[esi.fDigit]
    mov   [edi.fDigit],eax    // copy point position
    mov   al,[esi.nDim+3]
    mov   [edi.nDim+3],al

    mov   edi,[edi]     // this->digit
    mov   esi,[esi]     // a.digit
#else
    mov   eax,max_a_b
    mov   [edi+NDIGIT],eax
    mov   eax,[esi+FDIGIT]
    mov   [edi+FDIGIT],eax
    mov   al,[esi+SIGN]
    mov   [edi+SIGN],al

    mov   edi,[edi]
    mov   esi,[esi]
#endif
    mov   ecx,shift
    jecxz pre_Loop1
    cmp   same,0                  // this=&a ?
    jne   SetZero
    cmp   ecx,anDigit
    jbe   Copy
    mov   ecx,anDigit
    dec   ecx
    js    SetZero                   // in case a=0
  }
Copy:                             // aɊ֗^ȂRs[
  __asm {                         // shift ȉ̌Rs[
    mov   eax,[ecx*NBYTE+esi]
    mov   [ecx*NBYTE+edi],eax
    dec   ecx
    jns   Copy

  }
SetZero:                          // a ̌傫NA[
  __asm {
    mov   ecx,shift               // Vtg-L ̕ 0 ŃpfBO
    mov   edx,anDigit
    sub   ecx,edx
    jbe   pre_Loop1
    xor   eax,eax
  }
More:                             // a ̌傫NA
  __asm {
    mov   [edx*NBYTE+edi],eax
    inc   edx
    dec   ecx
    jnz   More
  }
pre_Loop1:                    // sum of overlapped digits
  __asm {
    mov   ebx,v
    mov   eax,shift
    lea   edi,[edi+eax*NBYTE]
    lea   esi,[esi+eax*NBYTE]
    xor   edx,edx
    mov   ecx,min_a_b
    sub   ecx,shift
    jng   SKIP1
    cmp   same,1                 // this=&a ?
    je    AddSelf                // a Ɩ߂lꍇ ʏ
    clc
  }
Loop1:                        // digit[j+shift]=a.digit[j+shift]+b.digit[j]
  __asm {
    mov   eax,[edx*NBYTE+esi]
    adc   eax,[edx*NBYTE+ebx]
    mov   [edx*NBYTE+edi],eax
    inc   edx
    dec   ecx
    jnz   Loop1               // ܂ׂ
    setc  Cflag               // save carry flag
    jmp   SKIP1
  }
AddSelf:                      // this==&a ̏ꍇ̕ʏ
  __asm {                     // ʏ͂ȂĂIs͂.
    mov   esi,ebx             // ͍̏̂߂̂
    xor   edx,edx             // edx=0 and carry flag=0
  }
Loop11:                       // digit[j+shift] += b.digit[j]
  __asm {
    mov   eax,[edx*NBYTE+esi]
    adc   [edx*NBYTE+edi],eax
    inc   edx
    dec   ecx
    jnz   Loop11
    setc  Cflag               // save carry flag
    mov   esi,edi
  }
SKIP1:
  __asm {
    mov   ecx,anDigit   // č̑傫,thisɉ
    cmp   ecx,bnDigit
    jge   set_flag              // a ̌̕傫
    mov   esi,ebx               // b ̌̕傫
  }
set_flag:
  __asm {                       // ۑ carry flag 𕜊
    xor   al,al
    cmp   al,Cflag              // carry flag on if Cflag>0
    mov   ecx,max_min           // č
    jecxz  Overflow             // č͂Ȃ
                                // xor gĂ͂ȂȂ
  }
Loop2:
  __asm {                                 // add remaining digits
    mov   eax,[edx*NBYTE+esi]  // a.digit[j]
    adc   eax,0                           // add carry
    mov   [edx*NBYTE+edi],eax
    inc   edx
    dec   ecx
    jnz   Loop2
  }
Overflow:
  __asm {
    jnc   CheckDigits                     // no overflow ?
    mov   dword ptr [edx*NBYTE+edi],1    // set overflow

    mov   esi,this
#ifdef __BORLANDC__
    inc   dword ptr [esi.nDigit]  // increase #digits
#else
    inc   dword ptr [esi+NDIGIT]
#endif
    jmp   RET1
  }

CheckDigits:
  __asm {
    mov esi,this
    mov ecx,max_a_b
#ifdef __BORLANDC__
    mov edi,[esi]
#else
    mov edi,[esi]
#endif
    jecxz ZERO
    xor eax,eax
  }
SearchNonZero: // l 0*b^s s<0 ƂɗL𒲂ׂKv
  __asm {
    cmp [ecx*NBYTE+edi-NBYTE],eax       // 0 ?
    jne NonZero
    dec ecx
    jnz SearchNonZero
  }
ZERO:
  __asm {
#ifdef __BORLANDC__
    mov byte ptr [esi.nDim+3],1
#else
    mov byte ptr [esi+SIGN],1
#endif
  }
NonZero:
  __asm {
#ifdef __BORLANDC__
    mov [esi.nDigit],ecx
#else
    mov [esi+NDIGIT],ecx
#endif
  }

RET1:
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
#endif

  return *this ;
}

