//
//  Copyright (C) by S.Tomabechi 1995
//  All rights reserved.
//
//  return residue r  s.t. |r| < |b/2|
//
//  Βlŏ]
//  ȒPȊ֐̊Ɍ\
//
#ifdef __BORLANDC__
#pragma inline
#endif

long amod(const long a,const long b)
{
  __asm {
    mov eax,a
    mov ebx,b
    or  ebx,ebx            // make b psotive
    jge b_is_positive
    neg ebx
  }
b_is_positive:
  __asm{
    cdq
    idiv ebx             // divide a by b
    mov eax,ebx          // a<-b
    shr eax,1            // b/2
    or  edx,edx          // a%b >0 ?
    jge Positive
    mov ecx,edx
    neg ecx
    cmp ecx,eax          // |remaidner| >  b/2 ?
    jle RET1
    add ebx,edx          // remaidner <- b+remainder
    mov edx,ebx
    jmp RET1
  }
Positive:
  __asm {
    cmp edx,eax          // remaidner >b/2 ?
    jle RET1
    sub edx,ebx          // remaidner <- remainder -b
  }
RET1:
#ifdef __BORLANDC__
  __asm {
    mov eax,edx
  }
  return _EAX ;
#else
  __asm {
    mov b,edx
  }
  return b ;
#endif
}
