// N numerator
// D denominator
#include "Mint.hpp"
#include <vector.h>

using namespace std ;

#if 0
void contfra1(Mint n,Mint d)
{
  Mint d1,r ;
  divide(n,d,d1,r) ;
  n=d ;
  d=r ;

  while( d!=0 ) {
    cout << endl << d1 ;
    divide(n,d,d1,r) ;
    n=d ;
    d=r ;
  }

  cout << endl << d1 ;
}
#endif


//
//   n (I) numerator
//   d (I) denominator
//   q (O) denominators of regular continued fraction
//
void contfra11(Mint n,Mint d,vector<Mint>& q)
{
    Mint d1,r ;
//  divide(n,d,d1,r) ;
//  q.push_back(d1) ;
//  Swap(n,d) ;           // n <-d
//  Swap(d,r) ;           // d <- r
    while( d!=0 ) {
        divide(n,d,d1,r) ;
        q.push_back(d1) ;
        Swap(n,d) ;              // n <-d
        Swap(d,r) ;              // d <- r
    }

}
