//
//  Copyright (C) by S.Tomabechi November 1993,2001
//  All rights reserved.
//
// ߂lƂāAűipeBjԂ.
//  ߂l 0 Ȃ珇͐s
//  n߂ iseq=0 ƂČĂ
//  iseq : sequential number of element
//
//#include <_defs.h>

#if 1
#include <vector>
#include "Mint.hpp"
using namespace std ;

int Permutation(unsigned long size,vector<unsigned long>& perm,Mint& iseq)
{
    long i,j,k,l ;
    unsigned long sign ;
    static vector<unsigned long> inv ;      // inversion
    static vector<unsigned long> next ;
    int head ;
    if( iseq==0 ) {
        inv.resize(size) ;
        next.resize(size) ;
        for( j=0 ; j<size ; j++ ) inv[j]=0 ;    // initial state ( without inversion)
        iseq++ ;
    }
    else {
        for( k=-1,j=size-2 ; j>=0 ; j-- )       // ₹ƂT
            if( inv[j]<(size-j-1) ) { k=j ; break ; }
        if( k<0 ) return 0 ;                    // ₹Ƃ낪Ȃ̂ŏI
        else {
            iseq++ ;
            inv[k]++ ;
            for( j=k+1 ; j<size-1 ; j++ ) inv[j]=0 ;    // ₵Ƃ납NA
        }
    }
//  cout << endl << " k l " << k << " " << l ;
//  cout << endl << "inv " << inv ;

//  vector<unsigned long > next(size) ;
//  cout << endl << inv ;
    for( head=size-1,j=size-2 ; j>=0 ; j-- ) {

        if( inv[j]==0 ) {
            next[j]=head ;
            head=j ;
        }
        else {
            for( l=head,i=1 ; i<inv[j] ; i++ ) l=next[l] ;
            k=next[l] ;
            next[l]=j ;
            next[j]=k ;
        }

    }


    unsigned long    m ;
    for( l=head,m=head,j=1 ; j<size ; j++ ) {
        k=next[l] ;
        if( m>k ) perm[l]=k ;
        else {
            perm[l]=m ;
            m=k ;
        }
        l=k ;
    }
    perm[l]=m ;
    for( sign=0,j=0 ; j<size ; j++ ) sign += inv[j] ;
    if( sign&1 ) return -1 ;
    else return 1 ;


}
#else

int Permutation(int size,vector<int>& perm,long& iseq)
{
    int i,j,k,l ;
    int sign ;
    static vector<int> inv ;        // inversion
    static vector<int> next ;
    int head ;
    if( iseq==0 ) {
    inv.resize(size) ;
    next.resize(size) ;
    for( j=0 ; j<size ; j++ ) inv[j]=0 ;    // inversion ̂Ȃ()
    iseq++ ;
    }
    else {
    for( k=-1,j=size-2 ; j>=0 ; j-- )       // ₹ƂT
        if( inv[j]<(size-j-1) ) { k=j ; break ; }
    if( k<0 ) return 0 ;                    // ₹Ƃ낪Ȃ̂ŏI
    else {
        iseq++ ;
        inv[k]++ ;
        for( j=k+1 ; j<size-1 ; j++ ) inv[j]=0 ;    // ₵Ƃ납NA
    }
    /*****
    for( k=-1, j=0 ; j<size ; j++ )
        if( inv[j]==(size-j-1) ) { k=j ; break ; }  // ͂⑝₹Ȃꏊ
    ******/
/*********
    for( l=-1,j=size-1 ; j>k ; j-- )
        if( inv[j] < (size-j-1) ) {
        l=j ;
        inv[j]++ ;
        break ;
        }
    if( l<0 ) {
        if( k==0 ) return 0 ;
        for( j=k ; j<size ; j++ ) inv[j]=0 ;
        inv[k-1]++ ;
    }
******/
    }
//  cout << endl << " k l " << k << " " << l ;
//  cout << endl << "inv " << inv ;

//  Array<int> next(size) ;
//  cout << endl << inv ;
    for( head=size-1,j=size-2 ; j>=0 ; j-- ) {

    if( inv[j]==0 ) {
        next[j]=head ;
        head=j ;
    }
    else {
        for( l=head,i=1 ; i<inv[j] ; i++ ) l=next[l] ;
        k=next[l] ;
        next[l]=j ;
        next[j]=k ;
    }

/*****************
    cout << endl    ;
    for( l=head,i=0 ; i<size-j ; i++ ) {
        cout << ' ' << l ;
        l=next[l] ;
    }
***************/
    }


    int m ;
    for( l=head,m=head,j=1 ; j<size ; j++ ) {
    k=next[l] ;
    if( m>k ) perm[l]=k ;
    else {
        perm[l]=m ;
        m=k ;
    }
    l=k ;
    }
    perm[l]=m ;
    for( sign=0,j=0 ; j<size ; j++ ) sign += inv[j] ;
    if( sign&1 ) return -1 ;
    else return 1 ;


}


#include "Vector.hpp"
#include "Array.hpp"

int Perm(int size,Array<int>& perm,long& iseq)
{
    int i,j,k,l ;
    int sign ;
    static Array<int> inv ;      // inversion
    static Array<int> next ;
    int head ;
    if( iseq==0 ) {
        inv.allocate(size) ;
        next.allocate(size) ;
        for( j=0 ; j<size ; j++ ) inv[j]=0 ;    // inversion ̂Ȃ()
        iseq++ ;
    }
    else {
        for( k=-1,j=size-2 ; j>=0 ; j-- )           // ₹ƂT
            if( inv[j]<(size-j-1) ) { k=j ; break ; }
        if( k<0 ) return 0 ;                                    // ₹Ƃ낪Ȃ̂ŏI
        else {
            iseq++ ;
            inv[k]++ ;
            for( j=k+1 ; j<size-1 ; j++ ) inv[j]=0 ;    // ₵Ƃ납NA
        }
        /*****
        for( k=-1, j=0 ; j<size ; j++ )
            if( inv[j]==(size-j-1) ) { k=j ; break ; }  // ͂⑝₹Ȃꏊ
        ******/
/*********
        for( l=-1,j=size-1 ; j>k ; j-- )
            if( inv[j] < (size-j-1) ) {
                l=j ;
                inv[j]++ ;
                break ;
            }
        if( l<0 ) {
            if( k==0 ) return 0 ;
            for( j=k ; j<size ; j++ ) inv[j]=0 ;
            inv[k-1]++ ;
        }
******/
    }
//  cout << endl << " k l " << k << " " << l ;
    cout << endl << "inv " << inv ;

//  Array<int> next(size) ;
//  cout << endl << inv ;
    for( head=size-1,j=size-2 ; j>=0 ; j-- ) {

        if( inv[j]==0 ) {
            next[j]=head ;
            head=j ;
        }
        else {
            for( l=head,i=1 ; i<inv[j] ; i++ ) l=next[l] ;
            k=next[l] ;
            next[l]=j ;
            next[j]=k ;
        }

/*****************
        cout << endl    ;
        for( l=head,i=0 ; i<size-j ; i++ ) {
            cout << ' ' << l ;
            l=next[l] ;
        }
***************/
    }


    int m ;
    for( l=head,m=head,j=1 ; j<size ; j++ ) {
        k=next[l] ;
        if( m>k ) perm[l]=k ;
        else {
            perm[l]=m ;
            m=k ;
        }
        l=k ;
    }
    perm[l]=m ;
    for( sign=0,j=0 ; j<size ; j++ ) sign += inv[j] ;
    if( sign&1 ) return -1 ;
    else return 1 ;


/********************************
    k=0 ;
    list[k]=size-1 ;
    head=k ;
    for( j=size-2 ; j>=0 ; j-- ) {
        k++ ;
        list[k]=j ;
        if( inv[j]==0 ) {
            next[k]=head ;
            head=k ;
        }
        else {
            l=head ;
            for( i=1 ; i<inv[j] ; i++ ) {
                l=next[l] ;
            }
            int wnext ;
            wnext=next[l] ;
            next[l]=k ;
            next[k]=wnext ;
        }

        cout << endl    ;
        for( l=head,i=0 ; i<=k ; i++ ) {
            cout << ' ' << list[l] ;
            l=next[l] ;
        }
    }
    ************************/
}
#endif
